
!SelectableListMorph methodsFor: 'selection' stamp: 'topa 1/17/2010 20:26'!
selection

	<bindable>
	"bindings stub"
	self bindings triggerEvent: #accessed with: (self -> #selection).
	self selectionIndex = 0 ifTrue: [ ^nil ].
	list ifNotNil: [ ^list at: self selectionIndex ].
	^ self getListItem: self selectionIndex! !

!SelectableListMorph methodsFor: 'selection' stamp: 'topa 1/18/2010 19:13'!
selection: item
	"Called from outside to request setting a new selection."

	<bindable>
	"bindings stub"
	(self selectionIndex ~= 0 and: [(item = (self getListItem: self selectionIndex))]) ifTrue: [^ self].
	self bindings triggerEvent: #aboutToChange with: (self -> #selection).
	self selectionIndex: (self getList indexOf: item).
	self bindings triggerEvent: #hasChanged with: (self -> #selection).
! !

!SelectableListMorph methodsFor: 'selection' stamp: 'topa 1/17/2010 20:39'!
selectionIndex

	<bindable>
	"bindings stub"
	self bindings triggerEvent: #accessed with: (self -> #selectionIndex).
	"return the index we have currently selected, or 0 if none"
	^self listMorph selectedRow ifNil: [ 0 ]! !

!SelectableListMorph methodsFor: 'selection' stamp: 'topa 2/9/2010 10:48'!
selectionIndex: index
	"Called from outside to request setting a new selection."

	<bindable>
	| row selectionDesc selectionIndexDesc |
	"bindings stub"
	(self listMorph selectedRow = index) ifTrue: [^self].
	selectionDesc := ChangeDescriptorMessage new
		operation: #selection; keyPathOfChange: #(); lastSender: self; changedValue: index.
	selectionIndexDesc := ChangeDescriptorMessage new
		operation: #selectionIndex; keyPathOfChange: #(); lastSender: self; changedValue: index.
	self bindings triggerEvent: #aboutToChange with: selectionDesc.
	self bindings triggerEvent: #aboutToChange with: selectionIndexDesc.

	"Called internally to select the index-th item."
	self unhighlightSelection.
	row := index ifNil: [ 0 ].
	row := row min: self getListSize.  "make sure we don't select past the end"
	self listMorph selectedRow: row.
	self highlightSelection.
	self scrollSelectionIntoView.
	
	self bindings triggerEvent: #hasChanged with: selectionIndexDesc.
	self bindings triggerEvent: #hasChanged with: selectionDesc.
! !

!Object methodsFor: '*bindings' stamp: 'topa 2/8/2010 09:48'!
getCollectionsFromKeypath: aKeyPath
"Implementation of the Keypath Pattern language for values.
Searches for all results from a given keypath on this object.
Returns all ManagedCollections that wrap the referenced objects/colls."
	
	| objectContext nextObjectContext remainingKeyPath currentKey objectBehindKey keyIterator lastManagedCollections lastMCLevel |
	
	self flag: #NeedsRefactoring.
	keyIterator := 0.
	lastMCLevel := 0.
	(aKeyPath isNil) ifTrue: [^nil].
	
	
	"should not be nil or something else than collection&symbol"
	(aKeyPath isArray)
	ifFalse: 
		[(aKeyPath isSymbol)
			ifTrue:
				[remainingKeyPath := Array with: aKeyPath]
			ifFalse:
				[^nil]]
	ifTrue:
		[remainingKeyPath := aKeyPath].
	
	"initializes the object context with self"
	objectContext := OrderedCollection with: self.
	nextObjectContext := OrderedCollection new.
	
	[remainingKeyPath isEmpty] whileFalse: [
		keyIterator := keyIterator + 1.
		currentKey := remainingKeyPath first.
		remainingKeyPath := remainingKeyPath allButFirst.
		
		"(A) arrangedObject"
		(currentKey asString == #arrangedObjects) ifTrue: [
				"error, arrangedObjects can't stand alone"
				^nil].
			
		"(B) selection"
		(currentKey asString == #selection) ifTrue: [
			"error, selection can't stand alone"
				^nil].
		
		
		objectContext do: [ :contextObject |
			"TODO: check if it exists"
			objectBehindKey := (contextObject instVarNamedOrNil: currentKey).
			
		"(C) collection"
		(objectBehindKey isCollection)
		ifTrue: [

			(objectBehindKey isManagedCollection) ifTrue: [
				"fetch all collections"
				(keyIterator > lastMCLevel) ifTrue: [
					keyIterator := lastMCLevel.
					lastManagedCollections := OrderedCollection new.
					]].

			"(C.1) collection & end"
			(remainingKeyPath isEmpty)
				ifTrue: [
					(objectBehindKey isManagedCollection) ifTrue: [
						"fetch all collections"
						lastManagedCollections add: objectBehindKey]
					ifFalse: [
						"COLLECTION IS NOT MANAGEDCOLLECTION"
						"nextObjectContext add: objectBehindKey." ]
				]
				ifFalse: [
					currentKey := remainingKeyPath first.
					remainingKeyPath := remainingKeyPath allButFirst.
					
					"(C.2) collection & arrangedObject"
					(currentKey == #arrangedObjects)
					ifTrue: [
							"fetch all inner objects in all collections"
							objectBehindKey actualCollection do: [ :innerobject |
								innerobject ifNil: [
									nextObjectContext add: innerobject.
									lastManagedCollections add: innerobject.
									]
							].
						]
					ifFalse: [
							"(C.3) collection & selection"
							(currentKey == #selection)
							ifTrue: [
								"fetch the selection of all collections"
								objectBehindKey selection ifNil: [
									nextObjectContext add: (objectBehindKey selection)].
							]
							"(C.4) error, after collection the keypath must contain a keyword"
							ifFalse: [	
								"objectBehindKey do: [ :innerobject |
									innerobject ifNotNil: [
										nextObjectContext add: innerobject.
										]
									].
								remainingKeyPath := (Array with: currentKey) , 
											remainingKeyPath."
								"error, wrong variables referenced, wrong keypath, ignore"
								^nil
								].
						].
					]
			]
		ifFalse: [
			"(D) value"
			(objectBehindKey isNil)
			ifFalse: [
				(remainingKeyPath isEmpty)
					ifTrue: [
						"do not add the value" ]
					ifFalse: [
						"just a value in the keypath (because it is a step-through procedure), so add it"
						nextObjectContext add: objectBehindKey.

						 ].
				]
			"(E) does not exist"
			ifTrue: [
					"error, variable is not set, do nothing and ignore this value"
				].
			].
		].
		objectContext := nextObjectContext.
		nextObjectContext := OrderedCollection new.
	].

	^lastManagedCollections.! !
